Loading...
Searching...
No Matches
log4shib::StringQueueAppender Class Reference

This class puts log messages in an in-memory queue. More...

`#include <StringQueueAppender.hh>`

Inheritance diagram for log4shib::StringQueueAppender:
[legend]
Collaboration diagram for log4shib::StringQueueAppender:
[legend]

## Public Member Functions

| StringQueueAppender (const std::string &name)
virtual | ~StringQueueAppender ()
virtual bool | reopen ()
| Reopens the output destination of this Appender, e.g.
virtual void | close ()
| Release any resources allocated within the appender such as file handles, network connections, etc.
virtual size_t | queueSize () const
| Return the current size of the message queue.
virtual std::queue< std::string > & | getQueue ()
| Return the queue to which the Appends adds messages.
virtual const std::queue< std::string > & | getQueue () const
| Return the queue to which the Appends adds messages.
virtual std::string | popMessage ()
| Pop the oldest log message from the front of the queue.
Public Member Functions inherited from log4shib::LayoutAppender
| LayoutAppender (const std::string &name)
virtual | ~LayoutAppender ()
virtual bool | requiresLayout () const
| Check if the appender requires a layout.
virtual void | setLayout (Layout *layout=NULL)
| Set the Layout for this appender.
Public Member Functions inherited from log4shib::AppenderSkeleton
virtual | ~AppenderSkeleton ()
| Destructor for AppenderSkeleton.
virtual void | doAppend (const LoggingEvent &event)
| Log in Appender specific way.
virtual void | setThreshold (Priority::Value priority)
| Set the threshold priority of this Appender.
virtual Priority::Value | getThreshold ()
| Get the threshold priority of this Appender.
virtual void | setFilter (Filter *filter)
| Set a Filter for this appender.
virtual Filter * | getFilter ()
| Get the Filter for this appender.
Public Member Functions inherited from log4shib::Appender
virtual | ~Appender ()
| Destructor for Appender.
const std::string & | getName () const
| Get the name of this appender.

## Protected Member Functions

virtual void | _append (const LoggingEvent &event)
| Appends the LoggingEvent to the queue.
Protected Member Functions inherited from log4shib::LayoutAppender
Layout & | _getLayout ()
| Return the layout of the appender.
Protected Member Functions inherited from log4shib::AppenderSkeleton
| AppenderSkeleton (const std::string &name)
| Constructor for AppenderSkeleton.
Protected Member Functions inherited from log4shib::Appender
| Appender (const std::string &name)
| Constructor for Appender.

## Protected Attributes

std::queue< std::string > | _queue

## Additional Inherited Members

Public Types inherited from log4shib::LayoutAppender
typedef BasicLayout | DefaultLayoutType
Static Public Member Functions inherited from log4shib::Appender
static Appender * | getAppender (const std::string &name)
| Get a pointer to an exitsing Appender.
static bool | reopenAll ()
| Call reopen() on all existing Appenders.
static void | closeAll ()
| Call reopen() on all existing Appenders.

## Detailed Description

This class puts log messages in an in-memory queue.

Its primary use is in test cases, but it may be useful elsewhere as well.

Since
  0.2.4

## Constructor & Destructor Documentation

## StringQueueAppender()

log4shib::StringQueueAppender::StringQueueAppender | ( | const std::string & | name | ) |

## ~StringQueueAppender()

log4shib::StringQueueAppender::~StringQueueAppender | ( |  | ) |

virtual

## Member Function Documentation

## _append()

void log4shib::StringQueueAppender::_append | ( | const LoggingEvent & | event | ) |

protected virtual

Appends the LoggingEvent to the queue.

Parameters

  event | the LoggingEvent to layout and append to the queue.

Implements log4shib::AppenderSkeleton.

## close()

void log4shib::StringQueueAppender::close | ( |  | ) |

virtual

Release any resources allocated within the appender such as file handles, network connections, etc.

Implements log4shib::AppenderSkeleton.

## getQueue() [1/2]

std::queue< std::string > & log4shib::StringQueueAppender::getQueue | ( |  | ) |

virtual

Return the queue to which the Appends adds messages.

Returns
  the message queue

## getQueue() [2/2]

const std::queue< std::string > & log4shib::StringQueueAppender::getQueue | ( |  | ) | const

virtual

Return the queue to which the Appends adds messages.

Returns
  the message queue

## popMessage()

std::string log4shib::StringQueueAppender::popMessage | ( |  | ) |

virtual

Pop the oldest log message from the front of the queue.

Returns
  the oldest log message

## queueSize()

size_t log4shib::StringQueueAppender::queueSize | ( |  | ) | const

virtual

Return the current size of the message queue.

Shorthand for getQueue().size().

Returns
  the queue size

## reopen()

bool log4shib::StringQueueAppender::reopen | ( |  | ) |

virtual

Reopens the output destination of this Appender, e.g.

the logfile or TCP socket.

Returns
  false if an error occured during reopening, true otherwise.

Reimplemented from log4shib::AppenderSkeleton.

## Member Data Documentation

## _queue

std::queue<std::string> log4shib::StringQueueAppender::_queue

protected

The documentation for this class was generated from the following files:

- StringQueueAppender.hh
- StringQueueAppender.cpp